window.onerror = function(message, source, lineno) {
  alert("Ошибка:"+message +"\n" + "файл:" + source + "\n" + "строка:" + lineno);
};

var GRID = 10987;
var title = null;
var defaultTitle = '';
var ifArr = {ios: false, ios4: false, itunes: false, android: false};
var dataAll = {games: gamesInit(xpromoGames)};
var imageArray = [];
var lft = {el: null, st: 0, dis: 0, max: 50, left: 100, margin: 430};
var screens = {el: null, elI: null, imgWidth: 300, num: 0, max: 5, flag: true, scroll: null};
var gallery = {el: null, num: 1, cnt: 0, max: 5, top: 0, idTime: null, id: null, control: {el: null, up: null, down: null}};
var swiper = {el: null, flag: true, zoom: 1, scroll: null, right: null};
var popUp = {el: null, elI: null, listWidth: 800, cntList: 1, flag: true, scroll: null, timerID: null};
var margeInImage = 4;
var currentDate = new Date();
var addedDate = '' + currentDate.getFullYear();
var whw;
var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
var BANNER_SITE = XPROMO_SITE + "news/";
var activeItem = 1;
var backLength = 1;

$(document).ready(function(){
  ifArr.ios = /iPhone|iPod|iPad/.test(navigator.userAgent);
  if (navigator.userAgent.toLowerCase().indexOf("os 4") != -1)
    ifArr.ios4 = true;
  $('#header BUTTON').bind('click', function(){showLeft()});
  lockitRender();
  title = document.querySelector('.title');
  defaultTitle = title.innerText;
  if (!defaultTitle.length)
    defaultTitle = title.innerHTML;

  setTitle(defaultTitle);

  gamesDirective['li']['game<-games']['p.red@onclick'] = function(arg) {
    return 'showGame(\'' + arg.item.id + '\'); return false';
  }
  initControl();
  fixHeight();
  renderPopUpGame();
  initFirstView();

});
function initControl() {
  gallery.el = $('#gallery');
  gallery.control.el = $('#control');
  gallery.control.up = gallery.control.el.find('#button_up');
  gallery.control.down = gallery.control.el.find('#button_down');
  gallery.el.bind('scroll', funcScroll);
  var SUPPORTS_TOUCH = 'ontouchstart' in window;
  if (SUPPORTS_TOUCH)
  {
    if (window.navigator.msPointerEnabled)
    {
      gallery.el.bind('MSPointerMove', funcScroll);
    }
    else
    {
      gallery.el.bind('touchmove', funcScroll);
    }
  }
}
function initFirstView() {
  $('.home-gf a').bind('click',function(){
    if ($('#platform:visible').length == 0 && $('#games:visible').length == 0)
    {
      showBack();
    }
    return false;
  });
  var platform = window.localStorage.getItem('xpromo.platform');
  if (!platform)
    platform = getPlatformFromId(gamesSelfId());
  platform = platform.toLowerCase();
  if (platform == 'iphone' || platform == 'ipad' || platform == 'mac')
  {
    ifArr.itunes = true;
  }
  else if (platform == 'android')
  {
    ifArr.android = true;
    window.addEventListener("popstate", function(e) {
      if (backLength == 1)
      {
        //simulateClick('@exit');
        $('#exitButton').click();
      }
      else
      {
        showBack();
      }
    }, false);
  }
  swiper.el = $('#games .swiper').eq(0);
  lft.el = $('#left').eq(0);
  swiper.right = $('#right').eq(0);
  if (ifArr.ios)
  {
    swiper.el.on('tap', 'p.red', function(){$(this).click();return false});
    swiper.el.on('tap', 'a', function(){simulateClick($(this).attr('href')); return false});
  }
  swiper.el.on('click', 'a', function(){return swiper.flag});
  swiper.scroll = new IScroll('#games', {
    tap: true,
    scrollbars: true,
    mouseWheel: true,
    useTransition: false,
    verticalScroll: function(_stage, _startX, _direction, _currentX) {
      switch(_stage)
      {
        case 'move':
          swiper.flag = false;
          break;
        case 'end':
          setTimeout(function(){swiper.flag = true;}, 500);
          break;
      }
    },
    horizontalScroll: function(_stage, _startX, _direction, _currentX) {
      if (_stage == 'move')
      {
        swiper.flag = false;
        var distance = Math.abs(_currentX - _startX);
        switch(lft.st)
        {
          case 0:
            if (_startX < lft.max)
              lft.st = 1;
            break;
          case 1:
            if (_direction == -1)
            {
              lft.dis = Math.max(lft.dis, distance - lft.max);
              if (lft.dis < lft.left)
              {
                scrollRight(0, lft.dis - lft.margin);
              }
              else if (lft.st != 2)
              {
                setTimeout(function(){lft.st = 2;swiper.flag = true;}, 500);
                swiper.el.trigger('mouseup');
                scrollRight(500, 0);
              }
            }
            break;
          case 2:
            if (_direction == 1)
            {
              if (distance > lft.max)
              {
                lft.dis = Math.max(lft.dis, distance - lft.max);
                if (lft.dis < lft.max)
                {
                  scrollRight(0,  0 - lft.dis);
                }
                else if(lft.st != 0)
                {
                  setTimeout(function(){lft.st = 0;swiper.flag = true;}, 500);
                  swiper.el.trigger('mouseup');
                  scrollRight(500, 0 - lft.margin);
                }
              }
            }
            break;
        }
      }
      else if (_stage == 'end')
      {
        if (lft.st == 1)
        {
          if (lft.dis < lft.left)
          {
            setTimeout(function(){lft.dis = 0;lft.st = 0;swiper.flag = true;}, 500);
            scrollRight(500, 0 - lft.margin);
          }
        }
      }
    }
  });
  if (ifArr.itunes)
  {
    $('#games_iphone, #games_ipad, #games_mac').bind('click',function(){
      var platform = $(this).attr('data-platform');
      window.localStorage.setItem('xpromo.ui.platform', platform);
      setTimeout(singleRenderGame, 100);
      return false;
    });
    singleRenderGame();
  }
  else
  {
    $('#platform').remove();
    window.localStorage.setItem('xpromo.ui.platform', platform);
    singleRenderGame();
  }
}
function scrollRight(_duration, _x) {
  _duration = (_duration/1000).toFixed(1);
  swiper.right.css({
    '-webkit-transition': '-webkit-transform ' + _duration + 's linear',
    'transition': 'transform ' + _duration + 's linear',
    '-webkit-transform': 'translate3d(' + _x +'px, 0px, 0px)',
    'transform': 'translate3d(' + _x +'px, 0px, 0px)'
  });
}
function fixHeight() {
  var userAgent = navigator.userAgent.toLowerCase();
  var iH = window.innerHeight;
  var iW = window.innerWidth;
  var zoom = Math.min(iH / 640, iW / 960) * 100;
  document.body.style.zoom = zoom + "%";
  if (userAgent.indexOf("trident") != -1)
  {
    document.body.style.width = 100 * 100 / zoom + "%";
  }
  else
  if (userAgent.indexOf("android 4") == -1)
    document.body.style["font-size"] = document.body.style.zoom;
  var iHn = iH / zoom * 100;
  $('#global').css('height', iHn);
  $('#popup .close').height((iHn - 582) / 2 + 50);
  whw = {w: gallery.el.width(), h: iHn};
  if (swiper.scroll != null)
  {
    if (swiper.zoom != (zoom / 100))
      swiper.scroll.refresh();
  }
  swiper.zoom = zoom / 100;
  setTimeout(fixHeight, 500);
}
function showLeft() {
  switch (lft.st)
  {
    case 0:
      scrollRight(500, 0);
      lft.st = 2;
      break;
    case 2:
      scrollRight(500, 0 - lft.margin);
      lft.st = 0;
      break;
  }
}
function setTitle(text) {
  if (title)
  {
    var temp_text = text;
    var i = temp_text.indexOf('G5 ');
    if (i != -1)
    {
      if (i < 12)
        temp_text = temp_text.replace('G5 ', '<img src="theme/spacer.gif" /> ');
    }
    title.innerHTML = temp_text;
  }
}
function categorySet(sort, tp) {
  if (lft.st == 2)
    singleRenderGame(sort, tp);
}

function singleRenderGame(sort, tp) {
  sort = typeof sort !== 'undefined' ? sort : false;
  tp = typeof tp !== 'undefined' ? tp : null;
  var getFromUrl = window.localStorage.getItem('xpromo.ui.platform');

  if (getFromUrl)
  {
    swiper.el.html($('#gt').html());
    var viewGames = {};
    viewGames.games = dataAll.games.slice(0);
    if (ifArr.itunes)
    {
      viewGames.games = viewGames.games.filter(function(element, index, array){
        var temp_platform = getPlatformFromId(element.id);
        return temp_platform == getFromUrl;
      });
    }
    if(tp != null)
    {
      if (tp != 'adv')
        tp = 'st';
      viewGames.games = viewGames.games.filter(function(element, index, array){
        return element.genre == tp;
      });
    }

    viewGames.games = replaceSort(viewGames.games, sort);
    //viewGames.games = viewGames.games.slice(0, 2);
    $('#left li.active').removeClass('active');
    var tmp = 0;
    if (sort)
    {
      tmp++;
      if (tp != null)
      {
        tmp++;
        if (tp != 'adv')
          tmp++;
      }
    }
    switch(tmp)
    {
      case 0:
        $('#left li#popular').addClass('active');
        break
      case 1:
        $('#left li#recent').addClass('active');
        break;
      case 2:
        $('#left li#adventure').addClass('active');
        break;
      case 3:
        $('#left li#strategy').addClass('active');
        break;
    }

    if ($('#platform').length > 0)
    {
      if (viewGames.games.length > 0)
      {
        $('#platform').hide();
        $('#games, #header button, #backButton').show();
        xpromoReport('web(\'xpromo/games.html\')');
        historyLog('games.html');
      }
    }
    else
    {
      $('#platform').hide();
      $('#games, #header button').show();
      xpromoReport('web(\'xpromo/games.html\')');
      historyLog('games.html');
    }

    if ($('#games:visible').length > 0)
    {
      if (lft.st != 0)
      {
        lft.st = 2;
        showLeft();
      }
      //$p("#games ul").autoRender(viewGames, gamesDirective);
      try{
        $p("#games ul").autoRender(viewGames, gamesDirective);
      } catch(e) {
        alert(e.name+' - '+ e.message);
      }
      swiper.scroll.scrollTo(0, 0, 0);
      swiper.scroll.refresh();
    }
  }
}
function showGame(_id) {
  $('#game').html($('#gmt').html());
  var text, flag, temp_text, tmp, i;
  text = newsLoadLang(_id + '/index');
  if (text == null)
  {
    return false;
  }
  else
  {
    text = lockitGet(text);
  }
  if (text)
  {
    if (checkVar(text['title']))
    {
      $('#game .title').html(text['title']);
      setTitle(text['title']);
    }
    if (checkVar(text['#slogan']))
    {
      $('#game .slogan').html(text['#slogan']);
    }
    else
    {
      $('#game .slogan').remove();
    }
    tmp = $('#game .icon');
    tmp.css('background-image', 'url(' + _id + '/' + iconNameFor(_id) + '?' + addedDate + ')');
    temp_text = iconStyleFor(_id, 3.75);
    temp_text = temp_text.split(';');
    for(var b in temp_text)
    {
      if (temp_text[b].indexOf(':') != -1)
      {
        temp_text[b] = temp_text[b].split(':');
        tmp.css(temp_text[b][0], temp_text[b][1]);
      }
    }
    if (checkVar(text['article span']))
    {
      $('#game .common').html(text['article span']);
    }
    else
    {
      $('#game .common').remove();
    }
    flag = false
    if (xpromoGames[_id]['date'] < currentDate)
      flag = true;
    var link_taf = null;
    if (flag)
    {
      if (text['#links'] != undefined)
      {
        if(checkVar(text['#links']['free']))
        {
          link_taf = text['#links']['free'];
        }
        else if(checkVar(text['#links']['lite']))
        {
          link_taf = text['#links']['lite'];
        }
        else if(checkVar(text['#links']['full']))
        {
          link_taf = text['#links']['full'];
        }
        else if(checkVar(text['#links']['download']))
        {
          link_taf = text['#links']['download'];
        }
        for (var link in text['#links'])
        {
          text['#links'][link] = convertLink('@ext(' + text['#links'][link] + ')', GRID);
          $('#game .buttons li.' + link).show().find('a').attr('href', text['#links'][link]);
        }
      }
    }
    else if (checkVar(text['#links']['temp']))
    {
      link_taf = text['#links']['temp'];
      $('#game .buttons li.temp').show().find('a').attr('href', text['#links']['temp']);
    }
    if (link_taf != null)
    {
      $('#game .tell').bind('click', function(){taf(_id, link_taf)});
    }
    else
    {
      $('#game .tell').remove();
    }
    if (checkVar(text['#youtube_id']))
    {
      $('#game .youtube').attr('data-src', text['#youtube_id']);
    }
    else
    {
      $('#game .youtube').remove();
    }
    i = 0;
    screens.el = $('#game .screens');
    screens.elI = screens.el.find('div').eq(0);
    if (ifArr.ios)
    {
      screens.elI.on('tap', 'a', function(){
        gallery.id = $(this).attr('data-id');
        gallery.num = $(this).find('img').attr('data-num');
        showGallery();
        return false
      });
    }
    else
    {
      screens.elI.on('click', 'a', function(){
        if (screens.flag)
        {
          gallery.id = $(this).attr('data-id');
          gallery.num = $(this).find('img').attr('data-num');
          showGallery();
        }
        return false
      });
    }
    var img_gal = screens.el.find('A');
    screens.max = img_gal.length;
    screens.flag = true;
    img_gal.each(function(){
      i++;
      $(this).attr('data-id', _id).find('IMG').attr('data-num', i).bind('error',function(){
          $(this).parents('li').remove();
          showYoutube(null);
        }).bind('load',function(){
          showYoutube($(this).attr('src'));
        }).attr('src', XPROMO_SITE + _id + '/screen' + i + '.jpg?' + addedDate);
    });
  }
  $('#platform, #games, #header button').hide();
  $('#middle').scrollTop(0);
  $('#game, #backButton').show();
  backLength++;
  xpromoReport('web(\'xpromo/game.html?this=' + _id + '\')');
  historyLog('game.html?this=' + _id);
}
function showYoutube(_src) {
  if (_src != null)
  {
    if (!inArray(_src, imageArray))
    {
      imageArray[imageArray.length] = _src;
    }
    if (imageArray.length == 1 && screens.el != null)
    {
      screens.num = 0;
      screens.imgWidth = screens.el.find('img[src="' + _src + '"]').eq(0).width() + margeInImage;
      screens.elI.width(screens.imgWidth * screens.max);
      screens.scroll =  new IScroll('#game .screens', {
        scrollX: true,
        scrollY: false,
        tap: true,
        useTransition: false,
        verticalScroll: function(_stage, _startX, _direction, _currentX) {
          switch(_stage)
          {
            case 'move':
              screens.flag = false;
              break;
            case 'end':
              setTimeout(function(){screens.flag = true;}, 500);
              break;
          }
        },
        horizontalScroll: function(_stage, _startX, _direction, _currentX) {
          switch(_stage)
          {
            case 'move':
              screens.flag = false;
              break;
            case 'end':
              setTimeout(function(){screens.flag = true;}, 500);
              break;
          }
        }
      });
      screens.el.bind('mouseout', function(){
        if (screens.elI !== null)
          screens.elI.trigger('mouseup');
      });
    }
  }
  else
  {
    screens.max--;
  }
  if (imageArray.length == screens.max && screens.max > 0 && screens.el != null)
  {
    var youtube = $('#game .youtube');
    if (youtube.length > 0)
    {
      youtube.show();
      renderYoutube();
      screens.el.css('margin-left', '320px');
      $('#game .header_screen SPAN').show();
      screens.scroll.refresh();
    }
  }
}
var player;
function createYoutubePlayer() {
  player = new YT.Player('youtube', {
    height: '390',
    width: '640',
    videoId: youtubeId,
    playerVars: { 'showinfo': 0 },
    events: {
//      'onReady': onPlayerReady,
      'onStateChange': onPlayerStateChange
    }
  });
}
function onYouTubeIframeAPIReady() {
  //alert("iframe_api");
}
/*function onPlayerReady(event) {

}*/
var done = false;
var player_state = -1;
function onPlayerStateChange(event) {
  player_state = event.data;
  //if ((event.data == YT.PlayerState.PLAYING || event.data == YT.PlayerState.PAUSED) && done) {
  if (done) {
    gallery.el.show();
    player.pauseVideo();
    alert('State='+event.data);
    //var startSeconds = player.getCurrentTime();
    //player.cueVideoById(youtubeId, startSeconds, startSeconds, 'medium');
  }
}

var youtubeId;
function renderYoutube() {
  var youtube = $('#game .youtube');
  if (youtube.filter(':visible').length > 0)
  {
    youtubeId = youtube.attr('data-src');
    if (checkVar(youtubeId))
    {
      if (ifArr.ios)
      {
        if (ifArr.ios4)
        {
          youtube.html('<div  style="border: 1px solid #3a69a6; margin:0;width:298px;height:223px;"><EMBED style="position:absolute;left:-430px;" src="http://www.youtube.com/v/' + youtubeId + '?showinfo=0" type="application/x-shockwave-flash" id="myplayer" wmode="window" width="100%" height="100%" allowFullScreen="true"/></div>');
        }
        else
        {
          createYoutubePlayer();
        }
      }
      else
      if (ifArr.itunes || navigator.userAgent.toLowerCase().indexOf('trident') != -1)
      {
        youtube.html('<div  style="border: 1px solid #3a69a6; margin:0;width:298px;height:223px;"><iframe class="youtube-player" type="text/html" src="http://www.youtube.com/embed/' + youtubeId + '?showinfo=0" frameborder="0" width="100%" height="100%"></iframe></div>');
      }
      else
      {
        youtube.html('<a href="vnd.youtube:' + youtubeId + '"><img class="video" style="background-image: url(http://img.youtube.com/vi/' + youtubeId + '/0.jpg);background-position:center center; -webkit-background-size: 100% auto;" src="theme/youtube_play.png"/></a>');
      }
    }
  }
}
function showBack() {
  var tmp = $('#middle>div:visible');
  var id = tmp.attr('id');
  switch (id)
  {
    case 'games':
      tmp.hide();
      $('#header button, #backButton').hide();
      if (lft.st != 0)
      {
        lft.st = 2;
        showLeft();
      }
      $('#platform').show();
      xpromoReport('web(\'xpromo/home-app.html\')');
      historyLog('home-app.html');
      break;
    case 'game':
      if ($('#platform').length == 0)
        $('#backButton').hide();
      tmp.hide();
      setTitle(defaultTitle);
      $('#games, #header button').show();
      xpromoReport('web(\'xpromo/games.html\')');
      historyLog('games.html');
      imageArray = [];
      screens.el = null;
      screens.elI = null;
      $('#game .youtube').remove();
      break;
    default:
      gallery.el.hide();
      $('#container').show();
      xpromoReport('web(\'xpromo/game.html?this=' + gallery.id + '\')');
      historyLog('game.html?this=' + gallery.id);
      if (ifArr.ios){
        if (!ifArr.ios4)
        {
          player.destroy()
          createYoutubePlayer();
        }
      }
      else
      {
        renderYoutube();
      }
      done = false;
  }
  $('#middle').scrollTop(0);
  backLength--;
}
function showGallery() {
  done = true;
  var this_id = gallery.id;
  var glv = gallery.el.find('#glv');
  $('#container').hide();
  if(ifArr.ios)
  {
      if(player_state == 1||player_state == 3)
        player.pauseVideo();
  }
  else
  {
    $('#game .youtube').html('');
  }
  glv.html(gallery.el.find('#glt').html());
  gallery.el.show();
  backLength++;
  xpromoReport('web(\'xpromo/gallery.html?this=' + gallery.id + '#' + gallery.num + '\')');
  historyLog('gallery.html?this=' + gallery.id + '#' + gallery.num);
  var whi = getWhi(this_id);
  var i = 0;
  gallery.max = 5;
  gallery.cnt = 0;
  glv.find('IMG').each(function(){
    i++;
    $(this).bind('error', function(){
      gallery.max--;
      $(this).parents('A').remove();
      fixGallery();
    }).bind('load', function(){
        var targ = $(this)[0];
        var hg = targ.naturalHeight;
        var wd = targ.naturalWidth;
        if (hg > wd)
        {
          var tmp_a = targ.parentNode;
          tmp_a.style.display = 'block';
          tmp_a.style.height = whi.h + 'px';
          var cssText = targ.style.cssText;
          cssText += '-webkit-transform: rotate(90deg);transform: rotate(90deg);';
          var tmp = (whi.h + whi.w) / 4;
          cssText += '-webkit-transform-origin: ' + tmp + 'px ' + tmp + 'px;';
          targ.style.cssText = cssText;
          targ.style.height = whi.w + 'px';
          targ.style.width = whi.h + 'px';
        }
        else
        {
          targ.style.width = whi.w + 'px';
          targ.style.height = whi.h + 'px';
        }
        gallery.cnt++;
        fixGallery();
      }).attr('src', XPROMO_SITE + this_id + '/screen' + i + '.jpg?' + addedDate);
  });
}
function newsLoadLang(name_config)
{
  var xmlhttp = new XMLHttpRequest();
  with (lockitXHR)
  {
    open("GET", name_config + ".txt", false);
    send(null);
    if (responseText)
    {
      try
      {
        return JSON.parse(responseText.replace(/[\r\n]/g, ''));
      }
      catch (e)
      {
        console.log(e);
      }
    }
  }
  return null;
}
function checkVar(a)
{
  if (a != undefined)
  {
    if (a.length > 0)
      return true;
  }
  return false;
}
function getWhi(this_id) {
  var wh;
  switch(getPlatformFromId(this_id))
  {
    case 'android': wh = {'w' : 800, 'h' : 480}; break;
    case 'pc':
    case 'ipad': wh = {'w' : 1024, 'h' : 768}; break;
    case 'mac': wh = {'w' : 1280, 'h' : 800}; break;
    default: wh = {'w' : 960, 'h' : 640};
  }
  var scale = Math.min((whw.w - 30) / wh.w, (whw.h - 30) / wh.h, 1);
  return {w: parseInt(wh.w * scale), h: parseInt(wh.h * scale)}
}
function fixGallery() {
  if (gallery.cnt == gallery.max)
  {
    var glv = $('#glv');
    gallery.el.scrollTop(glv.find('.image_' + gallery.num).offset().top - glv.offset().top);
    gallery.top = gallery.el.scrollTop();
    showControl(gallery.top);
  }
  else
  {
    gallery.control.el.css('top', gallery.el.scrollTop() + 'px');
  }
}
function funcScroll() {
  var tmp = gallery.el.scrollTop();
  if (gallery.top != tmp)
  {
    gallery.control.el.hide();
    if (gallery.idTime)
      window.clearTimeout(gallery.idTime);
    gallery.idTime = window.setTimeout('showControl(' + tmp + ')', 500);
  }
}
function showControl(a) {
  gallery.top = gallery.el.scrollTop();
  window.clearTimeout(gallery.idTime);
  if(gallery.top != a)
  {
    gallery.idTime = setTimeout('showControl(' + gallery.top + ')', 100);
  }
  else
  {
    gallery.control.el.css('top', a + 'px').show();
    if (gallery.top < 10)
    {
      gallery.control.up.hide();
    }
    else
    {
      gallery.control.up.show();
    }
    var tmp = $('#glv').height()  - (gallery.top + 640);
    if(tmp < 10)
    {
      gallery.control.down.hide();
    }
    else
    {
      gallery.control.down.show();
    }
  }
}
function renderPopUpGame() {
  var row2PopUp = {};
  row2PopUp.games = dataAll.games.slice(0);
  row2PopUp.games.sort(function(a, b)
  {
    return b.date - a.date;
  });
  var checkDate = new Date();
  row2PopUp.games = row2PopUp.games.filter(function(element, index, array) {
    return (element.date <= checkDate)
  });
  var last_visit = window.localStorage.getItem('xpromo.ui.lastvisit');
  if (last_visit == null)
  {
    row2PopUp.games = row2PopUp.games.slice(0, 8);
  }
  else
  {
    checkDate = new Date(last_visit);
    //checkDate.setDate(checkDate.getDate() - 80);
    row2PopUp.games = row2PopUp.games.filter(function(element, index, array) {
      return (element.date > checkDate)
    });
  }
  if (row2PopUp.games.length > 0)
  {
    var row1PopUp = {};
    row1PopUp.games = row2PopUp.games.filter(function (element, index, array) {
      return (index % 4) < 2;
    });
    row2PopUp.games = row2PopUp.games.filter(function (element, index, array) {
      return -1 == row1PopUp.games.indexOf(element);
    });
    var popUpDirective = {
      ".game": {
        "game<-games": {
          ".text h2": "game.name",
          ".text span": "game.slogan",
          "div.icon@style": function (arg) {
            return "background-image: url(" + arg.item.id + "/" + iconNameFor(arg.item.id) + ")";
          },
          "div.icon@class+": function (arg) {
            var platform = getPlatformFromId(arg.item.id);
            if (platform == 'mac' || platform == 'android' || platform == 'winrt')
              return ' icon_' + platform;
            return '';
          },
          "@href": function (arg) {
            var flag = true;
            var ret = '';
            if (arg.item.links.free != undefined) {
              ret = convertLink('@ext(' + arg.item.links.free + ')', GRID);
            }
            else if (arg.item.links.lite != undefined) {
              ret = convertLink('@ext(' + arg.item.links.lite + ')', GRID);
            }
            else if (arg.item.links.full != undefined) {
              ret = convertLink('@ext(' + arg.item.links.full + ')', GRID);
            }
            else if (arg.item.links.download != undefined) {
              ret = convertLink('@ext(' + arg.item.links.download + ')', GRID);
            }
            if (ret == '')
              ret = 'javascript:subscribeExec()';

            return ret;
          }
        }
      }
    };
    popUp.cntList = Math.max(popUp.cntList, Math.ceil(row1PopUp.games.length / 2));
    $p('#popup .row1').autoRender(row1PopUp, popUpDirective);
    $p('#popup .row2').autoRender(row2PopUp, popUpDirective);
    $('#popup').show();
    if (popUp.cntList > 1)
    {
      var gm = $('#popup .list .row1 .game');
      popUp.oneWidth = gm.eq(1).width();
      popUp.listWidth = (gm.eq(1).offset()['left'] - gm.eq(0).offset()['left']) * 2;
      popUp.el = $('#popup .list');
      popUp.elI = popUp.el.find('.list-inner').eq(0);
      popUp.el.find('a').bind('click', function(){return popUp.flag});
      popUp.elI.css({'width': 'auto', 'position': 'absolute'}).find('a').css('width', popUp.oneWidth);
      if (ifArr.ios)
        $('#popup .list').on('tap', 'a', function(){simulateClick($(this).attr('href')); return false});
      $('#popup .list').on('click', 'a', function(){return popUp.flag});
      popUp.scroll =  new IScroll('#popup .list', {
        scrollX: true,
        scrollY: false,
        tap: true,
        useTransition: false,
        verticalScroll: function(_stage, _startX, _direction, _currentX) {
          switch(_stage)
          {
            case 'move':
              popUp.flag = false;
              break;
            case 'end':
              setTimeout(function(){popUp.flag = true;}, 500);
              break;
          }
        },
        horizontalScroll: function(_stage, _startX, _direction, _currentX) {
          switch(_stage)
          {
            case 'move':
              popUp.flag = false;
              break;
            case 'end':
              setTimeout(function(){popUp.flag = true;}, 500);
              break;
          }
        }
      });
      /*$('#popup .list').bind('mouseout', function () {
      });*/
    }
    bannersInit();
  }
}
function closePopup() {
  var a = document.getElementById('popup');
  if (a)
  {
    a.style.display = 'none';
    var checkDate = new Date();
    var dateForWrite = checkDate.getFullYear() + '/';
    if ((checkDate.getMonth() + 1) < 10)
      dateForWrite += '0';
    dateForWrite += (checkDate.getMonth() + 1) + '/';
    if (checkDate.getDate() < 10)
      dateForWrite += '0';
    dateForWrite += checkDate.getDate();
    window.localStorage.setItem('xpromo.ui.lastvisit', dateForWrite);
  }
}
function bannersRender(_data)
{
  $p(".banners-box").autoRender(_data, {
    ".banner-item" :
    {
      "banner<-banners" :
      {
        "@id"         : function(arg) { return "banner-item-" + (arg.pos + 1); },
        "@href"       : "banner.href",
        "@style"      : function(arg)
        {
          var result = "";
          if (arg.pos != 0)
            result += "display:none;";
          if (arg.item.style)
            result += arg.item.style;
          return result;
        },
        ".icon@style" : function(arg)
        {
          if (arg.item.icon)
            return "background-image: url('" + XPROMO_SITE + arg.item.icon + "')";
          return "display:none;";
        },
        ".icon@alt_img" : function(arg) {
          if (arg.item.icon && isIpadNew){
            var tmp = arg.item.icon;
            var pos = tmp.indexOf('/');
            if(pos != -1)
              return tmp.substring(0, pos);
          }
          return '';
        },
        ".icon@class" : function(arg)
        {
          if (arg.item.icon)
          {
            var game_id = arg.item.icon;
            game_id = game_id.split('/');
            game_id = game_id[0];
            var platform = getPlatformFromId(game_id);
            return "icon icon_" + platform;
          }
          return "icon";
        },
        "div.text"    : "banner.text",
        "div.button"  : "banner.button",
        "div.button@style" : function(arg)
        {
          if (arg.item.button)
            return "display: inline-block;";
          return "";
        }
      }
    }
  });
  popUp.timerID = setTimeout(scrollerByTimeOut, 7000);
}
function bannersInit() {
  var bannerBase = window.localStorage.getItem("xpromo.news.base");
  if (bannerBase)
    BANNER_SITE = XPROMO_SITE + bannerBase;
  with (new XMLHttpRequest())
  {
    open("GET", BANNER_SITE + "banners.txt", true);
    onreadystatechange = function()
    {
      if (readyState != 4)
        return;

      var text;
      if (status == 200 ||
        responseText) // for local GET to work
      {
        text = responseText;
        window.localStorage.setItem("xpromo.banners", text);
      }
      else
      {
        text = window.localStorage.getItem("xpromo.banners");
      }
      if (text)
      {
        var xpromoBanners = lockitGet(JSON.parse(text));
        bannersRender(xpromoBanners);
      }
    }
    send(null);
  }
}
function scrollerByTimeOut() {
  var aId = (activeItem >= $('.banner-item').length) ? 1 : activeItem + 1;
  if (activeItem != aId)
  {
    $('#banner-item-' + activeItem).fadeOut(700);
    $('#banner-item-' + aId).fadeIn(700);
    activeItem = aId;
  }
  clearTimeout(popUp.timerID);
  popUp.timerID = setTimeout(scrollerByTimeOut, 7000);
}
function mainModal(_url) {
  window.open(_url, "_blank", "width=800px, height=600px");
}
function historyLog(_link) {
  var supportsHistoryAPI=!!(window.history && history.pushState);
  if (ifArr.android && supportsHistoryAPI)
    window.history.pushState(null, null, _link);
}