//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: more_games.js
//  Description:
//       Author: Davidovich V. (ringo@g5software.com)
if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
      window.mozRequestAnimationFrame ||
      window.oRequestAnimationFrame ||
      window.msRequestAnimationFrame ||
      function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
        window.setTimeout( callback, 1000 / 60 );
      };
  })();
}

if (window.localStorage.getItem("xpromo") == null || window.localStorage.getItem("xpromo") == "test")
{
  //window.localStorage.clear();
  //window.localStorage.setItem("xpromo.platform", "Android");
  window.localStorage.setItem("xpromo.platform", "iPhone");
  window.localStorage.setItem("xpromo",                "test");
  window.localStorage.setItem("xpromo.news.base",     "news.hd/");
  window.localStorage.setItem("xpromo.id",             "com.g5e.xpromodemo");
  window.localStorage.setItem("xpromo.games.self.id",  "com.g5e.xpromoapp");
  window.localStorage.setItem("xpromo.games.count",  "80");
  window.localStorage.setItem("xpromo.games.0.id",  "com.g5e.secretsociety");
  window.localStorage.setItem("xpromo.games.1.id",  "com.g5e.virtualcitysb");
  window.localStorage.setItem("xpromo.games.2.id",  "com.g5e.doomsdayprepperspg");
  window.localStorage.setItem("xpromo.games.3.id",  "com.g5e.sm2");
  window.localStorage.setItem("xpromo.games.4.id",  "com.g5e.islandcastaway2");
  window.localStorage.setItem("xpromo.games.5.id",  "com.g5e.twinmoons");
  window.localStorage.setItem("xpromo.games.6.id",  "com.g5e.islandcastaway");
  window.localStorage.setItem("xpromo.games.7.id",  "com.g5e.nightmaresdeep");
  window.localStorage.setItem("xpromo.games.8.id",  "com.g5e.dreamscapes");
  window.localStorage.setItem("xpromo.games.9.id",  "com.g5e.smm2");
  window.localStorage.setItem("xpromo.games.10.id",  "com.g5e.abyss");
  window.localStorage.setItem("xpromo.games.11.id",  "com.g5e.alchemymysteries");
  window.localStorage.setItem("xpromo.games.12.id",  "com.g5e.wac");
  window.localStorage.setItem("xpromo.games.13.id",  "com.fgames.lsoul");
  window.localStorage.setItem("xpromo.games.14.id",  "com.g5e.specialenquiry2");
  window.localStorage.setItem("xpromo.games.15.id",  "com.g5e.whisperoffear");
  window.localStorage.setItem("xpromo.games.16.id",  "com.orchidgames.royaltrouble");
  window.localStorage.setItem("xpromo.games.17.id",  "com.g5e.carnival");
  window.localStorage.setItem("xpromo.games.18.id",  "com.realore.janeshotel2");
  window.localStorage.setItem("xpromo.games.19.id",  "com.g5e.specialenquiry");
  window.localStorage.setItem("xpromo.games.20.id",  "com.g5e.standofood3");
  window.localStorage.setItem("xpromo.games.21.id",  "com.g5e.rightkill2");
  window.localStorage.setItem("xpromo.games.22.id",  "com.g5e.letters2");
  window.localStorage.setItem("xpromo.games.23.id",  "com.g5e.treasures3");
  window.localStorage.setItem("xpromo.games.24.id",  "com.g5e.rcmlegion");
  window.localStorage.setItem("xpromo.games.25.id",  "com.g5e.smm");
  window.localStorage.setItem("xpromo.games.26.id",  "com.g5e.virtualcity2");
  window.localStorage.setItem("xpromo.games.27.id",  "com.g5e.inbetweenland");
  window.localStorage.setItem("xpromo.games.28.id",  "com.g5e.spiritwalkers");
  window.localStorage.setItem("xpromo.games.29.id",  "com.g5e.buildalot4");
  window.localStorage.setItem("xpromo.games.30.id",  "com.g5e.crystalportal2");
  window.localStorage.setItem("xpromo.games.31.id",  "com.g5e.mahjonga1");
  window.localStorage.setItem("xpromo.games.32.id",  "com.g5e.crossworlds");
  window.localStorage.setItem("xpromo.games.33.id",  "com.g5e.sm");
  window.localStorage.setItem("xpromo.games.34.id",  "com.g5e.pilotbr1");
  window.localStorage.setItem("xpromo.games.35.id",  "com.g5e.mahjonga2");
  window.localStorage.setItem("xpromo.games.36.id",  "com.g5e.youdasurvivor2");
  window.localStorage.setItem("xpromo.games.37.id",  "com.g5e.treasures1");
  window.localStorage.setItem("xpromo.games.38.id",  "com.g5e.jack");
  window.localStorage.setItem("xpromo.games.39.id",  "com.g5e.pilotbr2");
  window.localStorage.setItem("xpromo.games.40.id",  "com.g5e.letters");
  window.localStorage.setItem("xpromo.games.41.id",  "com.g5e.virtualcity");
  window.localStorage.setItem("xpromo.games.42.id",  "com.g5e.standofood");
  window.localStorage.setItem("xpromo.games.43.id",  "com.g5e.bigfoot");
  window.localStorage.setItem("xpromo.games.44.id",  "com.g5e.youdasurvivor");
  window.localStorage.setItem("xpromo.games.45.id",  "com.g5e.treasureseekers4");
  window.localStorage.setItem("xpromo.games.46.id",  "com.jetdogs.sinistercity");
  window.localStorage.setItem("xpromo.games.47.id",  "com.g5e.strix");
  window.localStorage.setItem("xpromo.games.48.id",  "com.g5e.rightkill1");
  window.localStorage.setItem("xpromo.games.49.id",  "com.g5e.crystalportal");
  window.localStorage.setItem("xpromo.games.50.id",  "com.g5e.isladorada");
  window.localStorage.setItem("xpromo.games.51.id",  "com.g5e.magicianbook2");
  window.localStorage.setItem("xpromo.games.52.id",  "com.g5e.builditmiami");
  window.localStorage.setItem("xpromo.games.53.id",  "com.g5e.fiu");
  window.localStorage.setItem("xpromo.games.54.id",  "com.g5e.redrumdd");
  window.localStorage.setItem("xpromo.games.55.id",  "com.g5e.fiu80");
  window.localStorage.setItem("xpromo.games.56.id",  "com.g5e.ts2");
  window.localStorage.setItem("xpromo.games.57.id",  "com.g5e.hiddenwonders");
  window.localStorage.setItem("xpromo.games.58.id",  "com.g5e.epiconboard");
  window.localStorage.setItem("xpromo.games.59.id",  "com.g5e.totemtribegold");
  window.localStorage.setItem("xpromo.games.60.id",  "com.bbb.mastersofmystery");
  window.localStorage.setItem("xpromo.games.61.id",  "com.bbb.mastersofmystery2");
  window.localStorage.setItem("xpromo.games.62.id",  "com.g5e.kbrawe");
  window.localStorage.setItem("xpromo.games.63.id",  "com.g5e.fiu2");
  window.localStorage.setItem("xpromo.games.64.id",  "com.g5e.ocr");
  window.localStorage.setItem("xpromo.games.65.id",  "com.g5e.spiritofwondering");
  window.localStorage.setItem("xpromo.games.66.id",  "com.g5e.paranormal");
  window.localStorage.setItem("xpromo.games.67.id",  "com.g5e.magicianbook");
  window.localStorage.setItem("xpromo.games.68.id",  "com.g5e.artmogul");
  window.localStorage.setItem("xpromo.games.69.id",  "com.g5e.shardsoftime");
  window.localStorage.setItem("xpromo.games.70.id",  "com.g5e.sstory");
  window.localStorage.setItem("xpromo.games.71.id",  "com.g5e.greenjelly");
  window.localStorage.setItem("xpromo.games.72.id",  "com.g5e.epiclajangada");
  window.localStorage.setItem("xpromo.games.73.id",  "com.kranx.yumsters2");
  window.localStorage.setItem("xpromo.games.74.id",  "com.g5e.xpromoapp");
  window.localStorage.setItem("xpromo.games.75.id",  "com.realore.janeshotel");
  window.localStorage.setItem("xpromo.games.76.id",  "com.g5e.mushroomage");
  window.localStorage.setItem("xpromo.games.77.id",  "com.g5e.buildalot3");
  window.localStorage.setItem("xpromo.games.78.id",  "com.g5e.romanceofrome");
  window.localStorage.setItem("xpromo.games.79.id",  "com.g5e.brightstonemysteries");
  window.localStorage.setItem("xpromo.recomend.count",  "4");
  window.localStorage.setItem("xpromo.recomend.0.id",  "com.g5e.secretsociety");
  window.localStorage.setItem("xpromo.recomend.1.id",  "com.g5e.virtualcitysb");
  window.localStorage.setItem("xpromo.recomend.2.id",  "com.g5e.twinmoons");
  window.localStorage.setItem("xpromo.recomend.3.id",  "com.g5e.islandcastaway2");
}

var GAMES_NEW_DATE = new Date((new Date().getTime()) - 1000 * 60 * 60 * 24 * 42);
var userAgent = navigator.userAgent.toLowerCase();
var xpromoGames = xpromoGames || {};
var popUp = {el: null, elI: null, listWidth: 800, cntList: 1, flag: true, scroll: null, timerID: null};

for (var id in xpromoGames)
{
  try
  {
    var game  = xpromoGames[id];

    game.id   = id;
    game.date = new Date(game.date);

    if (game.date > GAMES_NEW_DATE)
      game.kind = "new";

    if (!("doomed" in game))
      game.doomed = 0;
  }
  catch (e)
  {
    delete xpromoGames[id];
  }
}

var activeItem = 1;
var timerID    = 1;
var myScroll   = {"adv":null, "st":null};
var isIpadNew = isIpadNewFunc();

var mainGames = gamesInit(xpromoGames);
var flagFiltering = (mainGames.length < 5)? true : false;

var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
var BANNER_SITE = XPROMO_SITE + "news/";

var bannerBase = window.localStorage.getItem("xpromo.news.base");
if (bannerBase)
  BANNER_SITE = XPROMO_SITE + bannerBase;

mainGames = mainGames.filter(function(element, index, array)
{
  var GRID = 10987;
  // filter out duplicates
  for (var i = 0; i < index; i++)
    if (array[i].id == element.id)
      return false;

  // create store link
  if (!element.links)
    return false;

  if ("download" in element.links)
    element.href = element.links.download;
  else
  if ("free" in element.links)
    element.href = element.links.free;
  else
  if ("lite" in element.links)
    element.href = element.links.lite;
  else
  if ("full" in element.links)
    element.href = element.links.full;
  else
  if ("temp" in element.links)
    element.href = element.links.temp;
  else
    return false;

  if (new Date().getTime() < element.date.getTime()&&!("temp" in element.links && flagFiltering))
    return false;

  element.href = convertLink("@ext(" + element.href + ")", GRID);
  return true;
});

function mainRender()
{
  var data = {},
    gamesBox;

  var gamesDirective =
  {
    "li" :
    {
      "game<-games" :
      {
        "a@href" : "game.href",
        ".name" : "game.name_short",
        ".icon@style" : function(arg) {
          return iconStyleFor(arg.item.id, 3);
        },
        ".icon@src" : function(arg) {
          return arg.item.id + "/" + iconNameFor(arg.item.id)
        },
        ".icon@alt_img" : function(arg) {
          if (isIpadNew)
            return arg.item.id;
          return '';
        }
      }
    }
  };

  mainGames = replaceSort(mainGames, false);
  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'st' || element.genre == 'both');});
  gamesBox = $p(".st .games-box-hidden ul.pplr");
  gamesBox.autoRender(data, gamesDirective);
  if (gamesBox[0].childElementCount > 0)
  $('.st .type-game span').append(' (' + gamesBox[0].childElementCount + ')');

  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'adv' || element.genre == 'both');});
  gamesBox = $p(".adv .games-box-hidden ul.pplr");
  gamesBox.autoRender(data, gamesDirective);
  if (gamesBox[0].childElementCount > 0)
  $('.adv .type-game span').append(' (' + gamesBox[0].childElementCount + ')');

  mainGames = replaceSort(mainGames, true);
  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'st' || element.genre == 'both');});
  gamesBox = $p(".st .games-box-hidden ul.rcnt");
  gamesBox.autoRender(data, gamesDirective);
  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'adv' || element.genre == 'both');});
  gamesBox = $p(".adv .games-box-hidden ul.rcnt");
  gamesBox.autoRender(data, gamesDirective);

  gamesBox = $p(".adv .games-box ul");
  gamesBox[0].innerHTML = $p(".adv .games-box-hidden ul")[0].innerHTML;
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);

  gamesBox = $p(".st .games-box ul");
  gamesBox[0].innerHTML = $p(".st .games-box-hidden ul")[0].innerHTML;
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
}

var flagToStore = flagToStore || false;

function changeType(a, tp, _type)
{
  var userAgent = navigator.userAgent.toLowerCase(),
    th = $(a);
  $("."+_type+" .select-type a").removeClass('selected');
  th.addClass('selected');
  var gamesBox = $p("."+_type+" .games-box ul");
  var donor = $p("."+_type+" .games-box-hidden ul." + tp);
  gamesBox[0].innerHTML  = donor[0].innerHTML;
  gamesBox[0].style.width = getWidthUL(donor[0].childElementCount);
  myScroll[_type].refresh();
  myScroll[_type].scrollTo(0, 0, 0);
}

function getWidthUL(cnt)
{
  var zoom = window.innerHeight / 768;
  var ret = Math.max(144 * cnt, window.innerWidth / zoom - 30);
  return ret + 'px';
}

function updateLayout()
{
  var zoom = (window.innerHeight / 768) * 100;
  document.body.style.zoom = zoom + "%";
  if (userAgent.indexOf("trident") != -1)
  {
    zoom = Math.round(zoom) - 1;
    document.body.style.width = 100 * 100 / zoom + "%";
  }
  else
  if (userAgent.indexOf("android 4") == -1)
  {
    document.body.style["font-size"] = document.body.style.zoom;
  }

  var gamesBox = $p(".st .games-box ul");
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  gamesBox = $p(".adv .games-box ul");
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);

  for(var key in myScroll)
  {
    if (myScroll[key])
      myScroll[key].refresh();
  }

}

function scrollGame()
{
  for(var key in myScroll)
  {
    if (myScroll[key])
    {
      if (myScroll[key].maxScrollX < 0)
      {
        setTimeout(function(key){
          return function(){
            myScroll[key].scrollTo(0, 0, 4000);
          }
        }(key), 1000);
      }
    }
  }
}

/*
* From Games.js
*
*/

function gamesInit(_table)
{
  var games = new Array(parseInt(window.localStorage.getItem("xpromo.games.count")));
  for (var i = 0; i < games.length; i++)
    games[i] = gamesLoadGame(_table, window.localStorage.getItem("xpromo.games." + i + ".id"));
  // filter unavailable games
  var self_id = window.localStorage.getItem("xpromo.games.self.id");
  if (null == self_id)
    self_id = window.localStorage.getItem("xpromo.id");
  games = games.filter(function(element){
    return element != null && element.id != self_id;
  });

  return games;
}

function gamesLoadGame(_table, _id)
{
  //TODO: check this code laters
  var lockit = lockitLoad(_id + "/index");
  if (!lockit)
  {
    console.log("not found: " + _id);
    return null;
  }
  var game = _table[_id];
  if (!game)
  {
    game = {};
    game.id = _id;
  }
  game.name       = lockit["title"];
  game.name_short = lockit["title_short"] || game.name;
  game.links      = lockit["#links"];
  game.genre      = lockit["genre"].toLowerCase();
  game.slogan     = lockit["#slogan"] || ""; //add for new GF
  if (!_table[_id])
    _table[_id] = game;
  return game;
}

function replaceSort(arr, flag)
{
  var arr_doomed, arr_middle, arr_top;
  arr_doomed = arr.filter(function(element, index, array){
    return (element.doomed < 0);
  });
  if (flag)
  {
    arr_doomed.sort(function(a, b){
      return b.date - a.date;
    });
  }
  if (flag)
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed == 0);
    });
    arr_middle.sort(function(a, b) {
      return b.date - a.date;
    });
    arr_top = arr.filter(function(element, index, array){
      return (element.doomed > 0);
    });
    arr_top.sort(function(a, b) {
      return b.date - a.date;
    });
    var ret = new Array();
    var i;
    for (var b in arr_top)
    {
      i = arr_top[b].doomed - 1;
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_top[b];
    }
    i = 0;
    for (var b in arr_middle)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_middle[b];
    }
    for (var b in arr_doomed)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_doomed[b];
    }
  }
  else
  {
    arr_middle = arr.filter(function(element, index, array){
      return (element.doomed > -1);
    });
    var ret = arr_middle.concat(arr_doomed);
  }
  return ret;
}

/*
* banners fetch
*/
function bannersFetch(_onload)
{
  var bannerRequest = new XMLHttpRequest();
  bannerRequest.open("GET", BANNER_SITE + "banners.txt", true);
  bannerRequest.onreadystatechange = function(){
    if (this.readyState != 4)
      return;

    var text;
    if (status == 200 || this.responseText) // for local GET to work
    {
      text = this.responseText;
      window.localStorage.setItem("xpromo.banners", text);
    }
    else
    {
      text = window.localStorage.getItem("xpromo.banners");
    }

    if (text)
    {
      var xpromoBanners = lockitGet(JSON.parse(text));
      _onload(xpromoBanners);
    }
    else
    {
      _onload(null);
    }
  }
  bannerRequest.send(null);
}

// download data
function bannersInit()
{
  bannersFetch(function(xpromoBanners)
  {
    $(document).ready(function()
    {
      var GRID = 10987;
      var data = {};
      var BannerDirective =
      {
        ".banner-item" :
        {
          "banner<-banners" :
          {
            "@id"         : function(arg) { return "banner-item-" + (arg.pos + 1); },
            "@href"       : "banner.href",
            "@style"      : function(arg)
            {
              var result = "";

              if (arg.pos != 0)
                result += "display:none;";

              if (arg.item.style)
                result += arg.item.style;

              return result;
            },
            ".icon@style" : function(arg)
            {
              if (arg.item.icon)
                return "background-image: url('" + XPROMO_SITE + arg.item.icon + "')";

              return "display:none;";
            },
            ".icon@alt_img" : function(arg) {
              if (arg.item.icon && isIpadNew)
              {
                var tmp = arg.item.icon;
                var pos = tmp.indexOf('/');
                if (pos != -1)
                  return tmp.substring(0, pos);
              }
              return '';
            },
            ".icon@class" : function(arg)
            {
              if (arg.item.icon)
              {
                var game_id = arg.item.icon;
                game_id = game_id.split('/');
                game_id = game_id[0];
                var platform = getPlatformFromId(game_id);
                return "icon icon_" + platform;
              }
              return "icon";
            },
            "div.text"    : "banner.text",
            ".+"          : function(arg) { return arg.item.button ? ("<div class='button'><span>" + arg.item.button + "</span></div>") : ""; }
          }
        }
      };

      data.banners = lockitThis.banners||{};
      if (xpromoBanners)
      {
        data.banners = xpromoBanners.banners.concat(data.banners);
      }

      var timeNow = new Date().getTime();

      data.banners = data.banners.filter(function(element, index, array)
      {
        if (element.begsAt)
        {
          var begsAt = new Date(element.begsAt);
          if (timeNow < begsAt.getTime())
            return false;
        }

        if (element.endsAt)
        {
          var endsAt = new Date(element.endsAt);
          if (timeNow >= endsAt.getTime())
            return false;
        }

        var self_id = window.localStorage.getItem("xpromo.games.self.id")||window.localStorage.getItem("xpromo.id");
        if (element.includes)
        {
          var arrIncludes = element.includes.split('|');
          if (!inArray(self_id, arrIncludes))
            return false;
        }

        if (element.excludes)
        {
          var arrExcludes = element.excludes.split('|');
          if (inArray(self_id, arrExcludes) != false)
            return false;
        }
        element.href = convertLink(element.href, GRID);
        return true;
      });
      //bannersRender(data);
      $p(".banners-box").autoRender(data, BannerDirective);
      if (isIpadNew)
        preloadBigImage();
    });
  });
}

/*
*
* */
function preloadBigImage()
{
  var arr_load = new Array();
  var tmp;
  $('div.latest-games .icon').each(function()
  {
    tmp = $(this).attr('alt_img');
    if (getPlatformFromId(tmp) == 'ipad')
    {
      if (!inArray(tmp, arr_load))
        arr_load.push(tmp);
    }
  });
  if (arr_load.length > 0)
  {
    var img = document.createElement('img');
    $(img).bind('load', function()
    {
      $('div.icon[alt_img="' + arr_load[0] + '"]').css('background-image', 'url(' + XPROMO_SITE + arr_load[0] + '/icon-big.jpg)').removeAttr('alt_img');
      $('img.icon[alt_img="' + arr_load[0] + '"]').attr('src', XPROMO_SITE + arr_load[0] + '/icon-big.jpg').removeAttr('alt_img');
      arr_load.shift();
      if (arr_load[0])
        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
    });
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
  }
}

/*
 *
 * */
function scrollerByTimeOut()
{
  var nextItem = (activeItem >= $('.banner-item').length) ? 1 : activeItem + 1;
  scroller(nextItem);
}

function scroller(aId)
{
  if (activeItem != aId)
  {
    $('.banner-item').fadeOut(700);
    //$('#banner-item-' + activeItem).fadeOut(700);
    $('#banner-item-' + aId).fadeIn(700);
    activeItem = aId;
  }

  clearTimeout(timerID);
  timerID = setTimeout(function ()
  {
    scrollerByTimeOut()
  }, 7000);
}
/*
*
* */
function mainModal(_url)
{
  window.open(_url, "_blank", "width=800px, height=600px");
}

function historyLog(_link)
{
  var supportsHistoryAPI=!!(window.history && history.pushState);
  if (ifArr.android && supportsHistoryAPI)
  {
    window.history.pushState(null, null, _link);
  }
  else
  {
    window.location.href = _link;
  }
}

function gamesSelfId()
{
  var result = window.localStorage.getItem("xpromo.games.self.id");
  if (null == result)
    result = window.localStorage.getItem("xpromo.id");

  return result;
}
/*
* Game Navigator
* */
function showPlatform()
{
 $('#platform').show();
}

function closePopup() {
  var a = document.getElementById('popup');
  if (a)
  {
    a.style.display = 'none';
    var checkDate = new Date();
    var dateForWrite = checkDate.getFullYear() + '/';
    if ((checkDate.getMonth() + 1) < 10)
      dateForWrite += '0';
    dateForWrite += (checkDate.getMonth() + 1) + '/';
    if (checkDate.getDate() < 10)
      dateForWrite += '0';
    dateForWrite += checkDate.getDate();
    window.localStorage.setItem('xpromo.ui.lastvisit', dateForWrite);
  }
}

function renderPopUpGame() {
  var row2PopUp = {},
      GRID = 10987;
  row2PopUp.games = mainGames.slice(0);
  row2PopUp.games.sort(function(a, b)
  {
    return b.date - a.date;
  });
  var checkDate = new Date();
  row2PopUp.games = row2PopUp.games.filter(function(element, index, array) {
    return (element.date <= checkDate)
  });
  var last_visit = window.localStorage.getItem('xpromo.ui.lastvisit');
  if (last_visit == null)
  {
    row2PopUp.games = row2PopUp.games.slice(0, 8);
  }
  else
  {
    checkDate = new Date(last_visit);
    //checkDate.setDate(checkDate.getDate() - 80);
    row2PopUp.games = row2PopUp.games.filter(function(element, index, array) {
      return (element.date > checkDate)
    });
  }
  if (row2PopUp.games.length > 0)
  {
    var row1PopUp = {};
    row1PopUp.games = row2PopUp.games.filter(function (element, index, array) {
      return (index % 4) < 2;
    });
    row2PopUp.games = row2PopUp.games.filter(function (element, index, array) {
      return -1 == row1PopUp.games.indexOf(element);
    });
    var popUpDirective = {
      ".game": {
        "game<-games": {
          ".text h2": "game.name",
          ".text span": "game.slogan",
          "div.icon@style": function (arg) {
            return "background-image: url(" + arg.item.id + "/" + iconNameFor(arg.item.id) + ")";
          },
          "div.icon@class+": function (arg) {
            var platform = getPlatformFromId(arg.item.id);
            if (platform == 'mac' || platform == 'android' || platform == 'winrt')
              return ' icon_' + platform;
            return '';
          },
          "@href": function (arg) {
            var flag = true;
            var ret = '';
            if (arg.item.links.free != undefined) {
              ret = convertLink('@ext(' + arg.item.links.free + ')', GRID);
            }
            else if (arg.item.links.lite != undefined) {
              ret = convertLink('@ext(' + arg.item.links.lite + ')', GRID);
            }
            else if (arg.item.links.full != undefined) {
              ret = convertLink('@ext(' + arg.item.links.full + ')', GRID);
            }
            else if (arg.item.links.download != undefined) {
              ret = convertLink('@ext(' + arg.item.links.download + ')', GRID);
            }
            if (ret == '')
              ret = 'javascript:subscribeExec()';

            return ret;
          }
        }
      }
    };
    popUp.cntList = Math.max(popUp.cntList, Math.ceil(row1PopUp.games.length / 2));
    $p('#popup .row1').autoRender(row1PopUp, popUpDirective);
    $p('#popup .row2').autoRender(row2PopUp, popUpDirective);
    $('#popup').show();
    if (popUp.cntList > 1)
    {
      var gm = $('#popup .list .row1 .game');
      popUp.oneWidth = gm.eq(1).width();
      popUp.listWidth = (gm.eq(1).offset()['left'] - gm.eq(0).offset()['left']) * 2;
      popUp.el = $('#popup .list');
      popUp.elI = popUp.el.find('.list-inner').eq(0);
      popUp.el.find('a').bind('click', function(){return popUp.flag});
      popUp.elI.css({'width': 'auto', 'position': 'absolute'}).find('a').css('width', popUp.oneWidth);
      if (ifArr.ios)
        $('#popup .list').on('tap', 'a', function(){simulateClick($(this).attr('href')); return false});
      $('#popup .list').on('click', 'a', function(){return popUp.flag});
      popUp.scroll =  new IScroll('#popup .list', {
        scrollX: true,
        scrollY: false,
        tap: true,
        useTransition: false,
        verticalScroll: function(_stage, _startX, _direction, _currentX) {
          switch(_stage)
          {
            case 'move':
              popUp.flag = false;
              break;
            case 'end':
              setTimeout(function(){popUp.flag = true;}, 500);
              break;
          }
        },
        horizontalScroll: function(_stage, _startX, _direction, _currentX) {
          switch(_stage)
          {
            case 'move':
              popUp.flag = false;
              break;
            case 'end':
              setTimeout(function(){popUp.flag = true;}, 500);
              break;
          }
        }
      });
      /*$('#popup .list').bind('mouseout', function () {
       });*/
    }
    //bannersInit();
  }
}